#include "VideoFrameToTextureLoader.h"

CVideoFrameToTextureLoader::CVideoFrameToTextureLoader() : CVideoFrameLoader()
{
     glTexImage3D = (PFNGLTEXIMAGE3DPROC) wglGetProcAddress("glTexImage3D");
}

CVideoFrameToTextureLoader::CVideoFrameToTextureLoader(PWSTR filePath) : CVideoFrameLoader(filePath)
{
    glTexImage3D = (PFNGLTEXIMAGE3DPROC) wglGetProcAddress("glTexImage3D");
}

CVideoFrameToTextureLoader::~CVideoFrameToTextureLoader(void)
{

}

VFLResult CVideoFrameToTextureLoader::loadAllFramesIntoTexture()
{
    return loadAllFramesIntoTexture(0, 0);
}

VFLResult CVideoFrameToTextureLoader::loadAllFramesIntoTexture(int offset, int distanceBetween)
{
   return loadAllFramesIntoTexture(offset, distanceBetween, 0);
}

VFLResult CVideoFrameToTextureLoader::loadAllFramesIntoTexture(int offset, int distanceBetween, int lastFrame)
{
    VFLResult vr = loadAllFramesIntoBuffer(offset, distanceBetween, lastFrame);

    if (vr != VFL_NO_MORE_FRAMES && vr != VFL_OK)
        return vr;

    if (VFLResult vr = transferVideoBufferToTexture() != VFL_OK)
        return vr;
    else
        return vr;
}

/*
VFLResult CVideoFrameToTextureLoader::addNextFrameToTexture()
{
    return addNextFrameToTexture(0);
}

VFLResult CVideoFrameToTextureLoader::addNextFrameToTexture(int distanceFromLast)
{
    VFLResult vrNFTB = addNextFrameToBuffer(distanceFromLast);

    if (vrNFTB != VFL_NO_MORE_FRAMES && vrNFTB != VFL_OK)
        return vrNFTB;

    if (VFLResult vr = transferVideoBufferToTexture() != VFL_OK)
        return vr;
    else
        return vrNFTB;
}
*/

VFLResult CVideoFrameToTextureLoader::transferVideoBufferToTexture()
{
    int width, height, frameCount;

    if (VFLResult vr = getVideoResolution(&width, &height) != VFL_OK)
        return vr;

    if (VFLResult vr = getBufferFrameCount(&frameCount) != VFL_OK)
        return vr;

    if (p_videoArray == NULL)
        copyVideoListToVideoArray();

    glTexImage3D(GL_TEXTURE_3D, 0, GL_RGB, width, height, frameCount, 0, GL_BGRA, GL_UNSIGNED_BYTE, p_videoArray);

    return VFL_OK;
}

VFLResult CVideoFrameToTextureLoader::resetProperties()
{
    //m_videoTexture = 0;

    return CVideoFrameLoader::resetProperties();
}
